% Resolution de l'equation de Laplace en 2D avec données de Dirichlet

% Maillage
N=100;
x=linspace(0,1,N+2);
y=linspace(1,0,N+2);
[X,Y]=meshgrid(x,y);
h=x(2)-x(1);


% Données physiques
f= @(x,y) 2*pi*pi*sin(pi*x).*sin(pi*y);
g1= @(x) zeros(size(x));
g3= @(x) zeros(size(x));
g4= @(y) zeros(size(y));
g2= @(y) zeros(size(y));
alpha=0;

% Resolution du probleme
A=mat_lap2d(alpha,N,N,h);
G1=g1(x);
G3=g3(x);
G4=g4(y');
G2=g2(y');
U=lap2d(A,f,G1,G2,G3,G4,X,Y,h);
surf(X,Y,U)
shading interp
      
      
% Sous domaines
m1=60;
m2=50;
X1=X(:,1:m1+2);
X2=X(:,m2:end);
Y1=Y(:,1:m1+2);
Y2=Y(:,m2:end);
G11=g1(X1(1,:));
G13=g3(X1(1,:));
G21=g1(X2(1,:));
G23=g3(X2(1,:));
A1=mat_lap2d(alpha,N,m1,h);
A2=mat_lap2d(alpha,N,N-m2+1,h);

figure
% Initialisation pour debuguer
%vald=U(:,m1+2);
%valg=U(:,m2);
vald=zeros(N+2,1);
valg=zeros(N+2,1);
for i=1:30
      U1=lap2d(A1,f,G11,vald,G13,G4,X1,Y1,h);
      surf(X1,Y1,U1)
      hold on
      U2=lap2d(A2,f,G21,G2,G23,valg,X2,Y2,h);
      surf(X2,Y2,U2)
      hold off
      pause
      vald=U2(:,m1-m2+3);
      valg=U1(:,m2);
      err2=max(max(abs(U(:,m2:end)-U2)))
      err1=max(max(abs(U(:,1:m1+2)-U1)))
end

